require 'nested_form'
require 'simple_form'
require 'bootstrap-datetimepicker-rails'
require 'select2-rails'
require 'ext_form/engine'
require 'ext_form/version'
require 'ext_form/helpers/tags'
require 'ext_form/helpers/form_tag_helper'
require 'ext_form/helpers/form_helper'

module ExtForm
  extend ActiveSupport::Autoload

  eager_autoload do
    autoload :Wrappers
    autoload :Layouts
    autoload :Inputs
    autoload :Components
    autoload :Builders
  end

  mattr_accessor :layout
  @@layout = 'DefaultLayout'

  mattr_accessor :default_wrapper
  @@default_wrapper = :ext

  mattr_accessor :default_layout
  @@default_layout = {
      layout: '1:1',
      spacing: '10',
      label_width: '15',
      max_width: '100',
      measure: '%'
  }

  mattr_accessor :form_class
  @@form_class = 'form-horizontal'

  mattr_accessor :locale
  @@locale = 'en'
  # Default way to setup SimpleForm. Run rails generate simple_form:install
  # to create a fresh initializer with all configuration values.
  def self.setup
    yield self
  end
end

SimpleForm::Wrappers::Many.send :include, ExtForm::Wrappers::ManyMixin
SimpleForm::Inputs::Base.send :include, ExtForm::Inputs::BaseMixin
SimpleForm::Wrappers::Single.send :include, ExtForm::Wrappers::SingleMixin
SimpleForm::Inputs::Base.send :include, ExtForm::Inputs::BootstrapInputsMixin
