module ExtForm
  module Layouts
    class BootstrapLayout
      include BaseLayout

      def width_available?(width)
        width && width.match(/^\d+$/) && width.to_i <= 12
      end

      def measure_available?(measure)
        true
      end

      def calc_actual_width
        self.layout_config[:max_width].to_i - 2 * self.layout_config[:spacing].to_i
      end

      def calculate_input_width(max_width, label_width, spacing, cols_sum, c)
        (((max_width.to_f - spacing.to_f * 2) / cols_sum * c).floor - label_width.to_i).to_s
      end
    end
  end
end