module ExtForm
  module Layouts
    class DefaultLayout
      include BaseLayout

      # Internal: decide option width whether is available,
      # possible formats are number% or number.
      #
      # width - option width
      #
      # Returns true or false.
      def width_available?(width)
        width && width.match(/^\d+\.?\d?$/)
      end

      def measure_available?(measure)
        %w(% px pt em cm).include?(measure)
      end

      def calc_actual_width
        self.layout.flatten.map(&:to_f).sum
      end

      def calculate_input_width(max_width, label_width, spacing, cols_sum, c)
        ((max_width.to_f - 2 * spacing.to_f) / cols_sum * c - label_width.to_f).to_s
      end
    end
  end
end